#include <bits/stdc++.h>

using namespace std;

int n,m;
long long c;
long long b[10005];
long long a[10005];

int main() 
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);
    
    cin >> n >> m;
    
    for(int i=1;i<=m;i++)
    {
        cin >> b[i];
    }
    
    for(int i=1;i<=n;i++)
    {
        a[i]=i;
    }
   
    for(int i=0;i<=n-m;i++)
    {
        for(int j=1;j<=m;j++)
        {
            a[i+b[j]]=a[i+j];
        }
    }
    
    cin >> c;
    long long mnoz=1;
    long long sol=0;
    
    for(int i=1;i<=n;i++)
    {
        mnoz=mnoz*c;
        mnoz=mnoz%(998244353);
        sol=(sol+mnoz*a[i])%(998244353);
    }
    
    cout << sol;
   
    return 0;
}